module Chervil
  class Lexer
    def initialize(source)
      @source = source
      @position = 0
    end

    def current_char
      @source[@position]
    end

    def advance
      @position += 1
    end

    def get_next_token
      case current_char
      when '('
        advance
        Token.new(:lparen, "(")
      when ')'
        advance
        Token.new(:rparen, ")")
      when nil
        Token.new(:eof, "eof")
      end
    end

    def tokenize
      tokens = Array.new
      loop do
        token = get_next_token
        tokens << token
        break if token.type == :eof
      end
      tokens
    end
  end
end
